/* Generated by GOB (v2.0.19)   (do not edit directly) */

/* End world hunger, donate to the World Food Programme, http://www.wfp.org */

#define GOB_VERSION_MAJOR 2
#define GOB_VERSION_MINOR 0
#define GOB_VERSION_PATCHLEVEL 19

#define selfp (self->_priv)

#include <string.h> /* memset() */

#include "vixn-application.h"

#ifdef G_LIKELY
#define ___GOB_LIKELY(expr) G_LIKELY(expr)
#define ___GOB_UNLIKELY(expr) G_UNLIKELY(expr)
#else /* ! G_LIKELY */
#define ___GOB_LIKELY(expr) (expr)
#define ___GOB_UNLIKELY(expr) (expr)
#endif /* G_LIKELY */

#line 22 "../src/vixn-application.gob"

#include "vixn-buffer.h"
#include "vixn-setting-registry.h"
#include "vixn-setting-target.h"
#include "vixn-version.h"
#include "vixn-view.h"
#include "vixn-window.h"

#include <ctype.h>
#include <stdlib.h>

GQuark vixn_application_setting_target_type;

void
vixn_application_parse_command_line(VixnApplicationCommandLineOptions *opts,
        int *argc, char ***argv, gboolean open_display)
{
    static char *geom = NULL;
    static GOptionEntry entries[] = {
        { "foreground", 'f', 0, G_OPTION_ARG_NONE, NULL,
                "Run in foreground until window is closed", NULL },
        { "geometry", 0, 0, G_OPTION_ARG_STRING, &geom,
                "Size window for W columns by H lines of characters", "WxH" },
        { NULL }
    };

    geom = NULL;
    entries[0].arg_data = &opts->foreground;
    opts->geom_w = opts->geom_h = 0;
    GOptionContext *ctx = g_option_context_new("[[+line_number] filename] ...");
    g_option_context_add_main_entries(ctx, entries, "vixn");
    g_option_context_add_group(ctx, gtk_get_option_group(open_display));
    g_option_context_set_help_enabled(ctx, !open_display);
    GError *err = NULL;
    if (!g_option_context_parse(ctx, argc, argv, &err))
    {
        g_critical("Option parsing failed: %s", err->message);
        g_error_free(err);
    }
    if (geom)
    {
        if (sscanf(geom, "%dx%d", &opts->geom_w, &opts->geom_h) != 2
                || opts->geom_w <= 0 || opts->geom_h <= 0)
        {
            g_warning("Ignoring invalid geometry '%s'", geom);
            opts->geom_w = opts->geom_h = 0;
        }
    }
}
static void
vixn_app__win_destroyed(GtkWidget *w, gboolean *open_flag)
{
    (void) w;
    *open_flag = FALSE;
}

static void
vixn_app__new_win_action(GSimpleAction *action, GVariant *param,
        gpointer handle)
{
    (void) action;
    (void) param;
    g_debug("New Window action");
    (void) vixn_application_open_window(handle, NULL);
}

static void
vixn_app__open_action(GSimpleAction *action, GVariant *param, gpointer handle)
{
    (void) action;
    (void) param;
    vixn_application_open_file_dialog(handle);
}

static void
vixn_app__about_action(GSimpleAction *action, GVariant *param, gpointer handle)
{
    (void) action;
    (void) param;
    (void) handle;
    GtkWidget *w = gtk_about_dialog_new();
    GtkAboutDialog *about = GTK_ABOUT_DIALOG(w);
    gtk_about_dialog_set_program_name(about, "Vixn");
    gtk_about_dialog_set_version(about, VIXN_VERSION);
    gtk_about_dialog_set_copyright(about, _("© 2013 Tony Houghton"));
    gtk_about_dialog_set_comments(about,
            _("Advanced text editor for programmers"));
    gtk_about_dialog_set_license_type(about, GTK_LICENSE_LGPL_3_0);
    gtk_about_dialog_set_website(about, "http://vixn.org");
    gtk_about_dialog_set_logo_icon_name(about, "vixn");
    (void) gtk_dialog_run(GTK_DIALOG(w));
    gtk_widget_destroy(w);
}

static void
vixn_app__quit_action(GSimpleAction *action, GVariant *param, gpointer handle)
{
    (void) action;
    (void) param;
    (void) handle;
    g_debug("Quit action");
    // FIXME: g_application_quit does nothing, so I suppose we'll have to
    // close all windows after checking modified
    g_application_quit(handle);
}

#define G_ACTION_ENTRY_PADDING {0,0,0}

static GActionEntry vixn_app__action_entries[] = {
    { "newwin", vixn_app__new_win_action, NULL, NULL, NULL,
            G_ACTION_ENTRY_PADDING},
    { "open", vixn_app__open_action, NULL, NULL, NULL,
            G_ACTION_ENTRY_PADDING},
    { "about", vixn_app__about_action, NULL, NULL, NULL,
            G_ACTION_ENTRY_PADDING},
    { "quit", vixn_app__quit_action, NULL, NULL, NULL,
            G_ACTION_ENTRY_PADDING},
};


#line 145 "vixn-application.c"
/* self casting macros */
#define SELF(x) VIXN_APPLICATION(x)
#define SELF_CONST(x) VIXN_APPLICATION_CONST(x)
#define IS_SELF(x) VIXN_IS_APPLICATION(x)
#define TYPE_SELF VIXN_TYPE_APPLICATION
#define SELF_CLASS(x) VIXN_APPLICATION_CLASS(x)

#define SELF_GET_CLASS(x) VIXN_APPLICATION_GET_CLASS(x)

/* self typedefs */
typedef VixnApplication Self;
typedef VixnApplicationClass SelfClass;

/* here are local prototypes */
static void vixn_application_init (VixnApplication * o) G_GNUC_UNUSED;
#line 200 "../src/vixn-application.gob"
static void ___7_vixn_application_startup (GApplication * gapp) G_GNUC_UNUSED;
#line 163 "vixn-application.c"
#line 224 "../src/vixn-application.gob"
static int ___8_vixn_application_command_line (GApplication * gapp, GApplicationCommandLine * cmdln) G_GNUC_UNUSED;
#line 166 "vixn-application.c"
static VixnWindow * ___real_vixn_application_open_window (VixnApplication * self, const char * filename);
static void ___real_vixn_application_open_file_dialog (VixnApplication * self);
static VixnBuffer * ___real_vixn_application_create_buffer (VixnApplication * self, const char * filename);
static VixnWindow * ___real_vixn_application_create_window (VixnApplication * self, const char * cwd, char const * const* env);
#line 348 "../src/vixn-application.gob"
static void vixn_application_class_init (VixnApplicationClass * class) G_GNUC_UNUSED;
#line 173 "vixn-application.c"

/* pointer to the class of our parent */
static GtkApplicationClass *parent_class = NULL;

/* Short form macros */
#define self_get_target_type vixn_application_get_target_type
#define self_set_setting vixn_application_set_setting
#define self_get_setting vixn_application_get_setting
#define self_get_target_for_type vixn_application_get_target_for_type
#define self_get_settings_map vixn_application_get_settings_map
#define self_is_holder vixn_application_is_holder
#define self_open_window vixn_application_open_window
#define self_open_file_dialog vixn_application_open_file_dialog
#define self_create_buffer vixn_application_create_buffer
#define self_create_window vixn_application_create_window
#define self_new vixn_application_new


static void
___Vixn_Setting_Target_init (VixnSettingTargetIface *iface)
{
#line 154 "../src/vixn-application.gob"
	iface->get_target_type = self_get_target_type;
#line 161 "../src/vixn-application.gob"
	iface->set_setting = self_set_setting;
#line 169 "../src/vixn-application.gob"
	iface->get_setting = self_get_setting;
#line 176 "../src/vixn-application.gob"
	iface->get_target_for_type = self_get_target_for_type;
#line 186 "../src/vixn-application.gob"
	iface->get_settings_map = self_get_settings_map;
#line 193 "../src/vixn-application.gob"
	iface->is_holder = self_is_holder;
#line 207 "vixn-application.c"
}

GType
vixn_application_get_type (void)
{
	static GType type = 0;

	if ___GOB_UNLIKELY(type == 0) {
		static const GTypeInfo info = {
			sizeof (VixnApplicationClass),
			(GBaseInitFunc) NULL,
			(GBaseFinalizeFunc) NULL,
			(GClassInitFunc) vixn_application_class_init,
			(GClassFinalizeFunc) NULL,
			NULL /* class_data */,
			sizeof (VixnApplication),
			0 /* n_preallocs */,
			(GInstanceInitFunc) vixn_application_init,
			NULL
		};

		static const GInterfaceInfo Vixn_Setting_Target_info = {
			(GInterfaceInitFunc) ___Vixn_Setting_Target_init,
			NULL,
			NULL
		};

		type = g_type_register_static (GTK_TYPE_APPLICATION, "VixnApplication", &info, (GTypeFlags)0);
		g_type_add_interface_static (type,
			VIXN_TYPE_SETTING_TARGET,
			&Vixn_Setting_Target_info);
	}

	return type;
}

/* a macro for creating a new object of our type */
#define GET_NEW ((VixnApplication *)g_object_new(vixn_application_get_type(), NULL))

/* a function for creating a new object of our type */
#include <stdarg.h>
static VixnApplication * GET_NEW_VARG (const char *first, ...) G_GNUC_UNUSED;
static VixnApplication *
GET_NEW_VARG (const char *first, ...)
{
	VixnApplication *ret;
	va_list ap;
	va_start (ap, first);
	ret = (VixnApplication *)g_object_new_valist (vixn_application_get_type (), first, ap);
	va_end (ap);
	return ret;
}


static void
___finalize(GObject *obj_self)
{
#define __GOB_FUNCTION__ "Vixn:Application::finalize"
	VixnApplication *self G_GNUC_UNUSED = VIXN_APPLICATION (obj_self);
#line 151 "../src/vixn-application.gob"
	if(self->settings_map) { vixn_setting_target_free_map ((gpointer) self->settings_map); self->settings_map = NULL; }
#line 269 "vixn-application.c"
	if(G_OBJECT_CLASS(parent_class)->finalize) \
		(* G_OBJECT_CLASS(parent_class)->finalize)(obj_self);
}
#undef __GOB_FUNCTION__

static void 
vixn_application_init (VixnApplication * o G_GNUC_UNUSED)
{
#define __GOB_FUNCTION__ "Vixn:Application::init"
#line 150 "../src/vixn-application.gob"
	o->settings_map =  vixn_setting_target_create_settings_map(); ;
#line 281 "vixn-application.c"
}
#undef __GOB_FUNCTION__
#line 348 "../src/vixn-application.gob"
static void 
vixn_application_class_init (VixnApplicationClass * class G_GNUC_UNUSED)
{
#line 288 "vixn-application.c"
#define __GOB_FUNCTION__ "Vixn:Application::class_init"
	GObjectClass *g_object_class G_GNUC_UNUSED = (GObjectClass*) class;
	GApplicationClass *g_application_class = (GApplicationClass *)class;

	parent_class = g_type_class_ref (GTK_TYPE_APPLICATION);

#line 200 "../src/vixn-application.gob"
	g_application_class->startup = ___7_vixn_application_startup;
#line 224 "../src/vixn-application.gob"
	g_application_class->command_line = ___8_vixn_application_command_line;
#line 281 "../src/vixn-application.gob"
	class->open_window = ___real_vixn_application_open_window;
#line 296 "../src/vixn-application.gob"
	class->open_file_dialog = ___real_vixn_application_open_file_dialog;
#line 316 "../src/vixn-application.gob"
	class->create_buffer = ___real_vixn_application_create_buffer;
#line 328 "../src/vixn-application.gob"
	class->create_window = ___real_vixn_application_create_window;
#line 307 "vixn-application.c"
	g_object_class->finalize = ___finalize;
 {
#line 349 "../src/vixn-application.gob"

        vixn_application_setting_target_type =
                g_quark_from_static_string("stngs:app");
    
#line 315 "vixn-application.c"
 }
}
#undef __GOB_FUNCTION__


#line 154 "../src/vixn-application.gob"
GQuark 
vixn_application_get_target_type (const VixnSettingTarget * self)
{
#line 325 "vixn-application.c"
#define __GOB_FUNCTION__ "Vixn:Application::get_target_type"
{
#line 155 "../src/vixn-application.gob"
	
        (void) self;
        return vixn_application_setting_target_type;
    }}
#line 333 "vixn-application.c"
#undef __GOB_FUNCTION__

#line 161 "../src/vixn-application.gob"
void 
vixn_application_set_setting (VixnSettingTarget * self, const char * name, VixnSettingValue value)
{
#line 340 "vixn-application.c"
#define __GOB_FUNCTION__ "Vixn:Application::set_setting"
{
#line 164 "../src/vixn-application.gob"
	
        vixn_setting_target_default_set(self, name, value);
    }}
#line 347 "vixn-application.c"
#undef __GOB_FUNCTION__

#line 169 "../src/vixn-application.gob"
VixnSettingValue 
vixn_application_get_setting (const VixnSettingTarget * self, const char * name)
{
#line 354 "vixn-application.c"
#define __GOB_FUNCTION__ "Vixn:Application::get_setting"
{
#line 171 "../src/vixn-application.gob"
	
        return vixn_setting_target_default_get(self, name);
    }}
#line 361 "vixn-application.c"
#undef __GOB_FUNCTION__

#line 176 "../src/vixn-application.gob"
VixnSettingTarget * 
vixn_application_get_target_for_type (VixnSettingTarget * self, GQuark q)
{
#line 368 "vixn-application.c"
#define __GOB_FUNCTION__ "Vixn:Application::get_target_for_type"
{
#line 178 "../src/vixn-application.gob"
	
        if (q == vixn_application_setting_target_type)
            return self;
        else
            return NULL;
    }}
#line 378 "vixn-application.c"
#undef __GOB_FUNCTION__

#line 186 "../src/vixn-application.gob"
GHashTable * 
vixn_application_get_settings_map (VixnSettingTarget * self)
{
#line 385 "vixn-application.c"
#define __GOB_FUNCTION__ "Vixn:Application::get_settings_map"
{
#line 188 "../src/vixn-application.gob"
	
        return VIXN_APPLICATION(self)->settings_map;
    }}
#line 392 "vixn-application.c"
#undef __GOB_FUNCTION__

#line 193 "../src/vixn-application.gob"
gboolean 
vixn_application_is_holder (const VixnSettingTarget * self)
{
#line 399 "vixn-application.c"
#define __GOB_FUNCTION__ "Vixn:Application::is_holder"
{
#line 195 "../src/vixn-application.gob"
	
        (void) self;
        return FALSE;
    }}
#line 407 "vixn-application.c"
#undef __GOB_FUNCTION__

#line 200 "../src/vixn-application.gob"
static void 
___7_vixn_application_startup (GApplication * gapp G_GNUC_UNUSED)
#line 413 "vixn-application.c"
#define PARENT_HANDLER(___gapp) \
	{ if(G_APPLICATION_CLASS(parent_class)->startup) \
		(* G_APPLICATION_CLASS(parent_class)->startup)(___gapp); }
{
#define __GOB_FUNCTION__ "Vixn:Application::startup"
{
#line 203 "../src/vixn-application.gob"
	
        G_APPLICATION_CLASS(parent_class)->startup(gapp);
        char *menus_file = g_build_filename(PKGDATADIR, "menus", NULL);
        GtkBuilder *builder = gtk_builder_new();
        GError *err = NULL;
        if (!gtk_builder_add_from_file(builder, menus_file, &err))
        {
            g_error("Failed to load menus definition: %s", err->message);
        }
        g_free(menus_file);
        g_action_map_add_action_entries(G_ACTION_MAP(gapp),
                vixn_app__action_entries,
                G_N_ELEMENTS(vixn_app__action_entries), gapp);
        GtkApplication *gtkapp = GTK_APPLICATION(gapp);
        gtk_application_set_app_menu(gtkapp,
                G_MENU_MODEL(gtk_builder_get_object(builder, "app-menu")));
        gtk_application_set_menubar(gtkapp,
                G_MENU_MODEL(gtk_builder_get_object(builder, "menubar")));
        g_object_unref(builder);
    }}
#line 441 "vixn-application.c"
#undef __GOB_FUNCTION__
#undef PARENT_HANDLER

#line 224 "../src/vixn-application.gob"
static int 
___8_vixn_application_command_line (GApplication * gapp G_GNUC_UNUSED, GApplicationCommandLine * cmdln)
#line 448 "vixn-application.c"
#define PARENT_HANDLER(___gapp,___cmdln) \
	((G_APPLICATION_CLASS(parent_class)->command_line)? \
		(* G_APPLICATION_CLASS(parent_class)->command_line)(___gapp,___cmdln): \
		((int )0))
{
#define __GOB_FUNCTION__ "Vixn:Application::command_line"
{
#line 227 "../src/vixn-application.gob"
	
        // FIXME: May want to add views to an existing window
        VixnApplication *vapp = VIXN_APPLICATION(gapp);
        int argc;
        char **argv = g_application_command_line_get_arguments(cmdln, &argc);
        VixnApplicationCommandLineOptions opts;
        vixn_application_parse_command_line(&opts, &argc, &argv, TRUE);
        VixnWindow *win = vixn_application_create_window(vapp,
                g_application_command_line_get_cwd(cmdln),
                g_application_command_line_get_environ(cmdln));
        gboolean opened = FALSE;
        int n;
        for (n = 1; n < argc; ++n)
        {
            int ln = 0;
            if (argv[n][0] == '+' && n < argc - 1)
            {
                const char *c = argv[n] + 1;
                gboolean all_digits = TRUE;
                while (*c)
                {
                    if (!isdigit(*(c++)))
                    {
                        all_digits = FALSE;
                        break;
                    }
                }
                if (all_digits)
                {
                    ln = atoi(argv[n] + 1);
                    ++n;
                }
            }
            vixn_window_open_file_in_new_tab(win, argv[n]);
            (void) ln;  // FIXME: Move view to ln
            opened = TRUE;
        }
        if (!opened)
        {
            vixn_window_open_file_in_new_tab(win, NULL);
        }
        gtk_window_present(GTK_WINDOW(win));
        if (opts.foreground)
        {
            // Don't return from this function until window is closed
            gboolean win_open = TRUE;
            g_signal_connect(win, "destroy",
                    G_CALLBACK(vixn_app__win_destroyed), &win_open);
            while (win_open)
                gtk_main_iteration();
        }
        return 0;
    }}
#line 510 "vixn-application.c"
#undef __GOB_FUNCTION__
#undef PARENT_HANDLER

#line 281 "../src/vixn-application.gob"
VixnWindow * 
vixn_application_open_window (VixnApplication * self, const char * filename)
{
#line 518 "vixn-application.c"
	VixnApplicationClass *klass;
#line 281 "../src/vixn-application.gob"
	g_return_val_if_fail (self != NULL, (VixnWindow * )0);
#line 281 "../src/vixn-application.gob"
	g_return_val_if_fail (VIXN_IS_APPLICATION (self), (VixnWindow * )0);
#line 524 "vixn-application.c"
	klass = VIXN_APPLICATION_GET_CLASS(self);

	if(klass->open_window)
		return (*klass->open_window)(self,filename);
	else
		return (VixnWindow * )(0);
}
#line 281 "../src/vixn-application.gob"
static VixnWindow * 
___real_vixn_application_open_window (VixnApplication * self G_GNUC_UNUSED, const char * filename)
{
#line 536 "vixn-application.c"
#define __GOB_FUNCTION__ "Vixn:Application::open_window"
{
#line 283 "../src/vixn-application.gob"
	
        VixnWindow *win = VIXN_WINDOW(
                gtk_application_get_active_window(GTK_APPLICATION(self)));
        char *cwd = vixn_setting_target_get_setting(
                VIXN_SETTING_TARGET(win), "cwd").s;
        win = vixn_application_create_window(self, cwd,
                vixn_window_get_env(win));
        g_free(cwd);
        vixn_window_open_file_in_new_tab(win, filename);
        gtk_window_present(GTK_WINDOW(win));
        return win;
    }}
#line 552 "vixn-application.c"
#undef __GOB_FUNCTION__

#line 296 "../src/vixn-application.gob"
void 
vixn_application_open_file_dialog (VixnApplication * self)
{
#line 559 "vixn-application.c"
	VixnApplicationClass *klass;
#line 296 "../src/vixn-application.gob"
	g_return_if_fail (self != NULL);
#line 296 "../src/vixn-application.gob"
	g_return_if_fail (VIXN_IS_APPLICATION (self));
#line 565 "vixn-application.c"
	klass = VIXN_APPLICATION_GET_CLASS(self);

	if(klass->open_file_dialog)
		(*klass->open_file_dialog)(self);
}
#line 296 "../src/vixn-application.gob"
static void 
___real_vixn_application_open_file_dialog (VixnApplication * self G_GNUC_UNUSED)
{
#line 575 "vixn-application.c"
#define __GOB_FUNCTION__ "Vixn:Application::open_file_dialog"
{
#line 298 "../src/vixn-application.gob"
	
        char *filename = vixn_window_run_file_chooser(
                VIXN_WINDOW(gtk_application_get_active_window(
                        GTK_APPLICATION(self))),
                GTK_FILE_CHOOSER_ACTION_OPEN, NULL);
        if (filename)
        {
            self_open_window(self, filename);
            g_free(filename);
        }
    }}
#line 590 "vixn-application.c"
#undef __GOB_FUNCTION__

/**
 * vixn_application_create_buffer:
 * @filename: (allow-none):
 * Creates a buffer which will optionally contain a file, but does not
 * actually load the file yet, or associate the buffer with a view.
 **/
#line 316 "../src/vixn-application.gob"
VixnBuffer * 
vixn_application_create_buffer (VixnApplication * self, const char * filename)
{
#line 603 "vixn-application.c"
	VixnApplicationClass *klass;
#line 316 "../src/vixn-application.gob"
	g_return_val_if_fail (self != NULL, (VixnBuffer * )0);
#line 316 "../src/vixn-application.gob"
	g_return_val_if_fail (VIXN_IS_APPLICATION (self), (VixnBuffer * )0);
#line 609 "vixn-application.c"
	klass = VIXN_APPLICATION_GET_CLASS(self);

	if(klass->create_buffer)
		return (*klass->create_buffer)(self,filename);
	else
		return (VixnBuffer * )(0);
}
#line 316 "../src/vixn-application.gob"
static VixnBuffer * 
___real_vixn_application_create_buffer (VixnApplication * self G_GNUC_UNUSED, const char * filename)
{
#line 621 "vixn-application.c"
#define __GOB_FUNCTION__ "Vixn:Application::create_buffer"
{
#line 318 "../src/vixn-application.gob"
	
        (void) self;
        (void) filename;
        return vixn_buffer_new();
    }}
#line 630 "vixn-application.c"
#undef __GOB_FUNCTION__

/**
 * vixn_application_create_window:
 * Creates an empty window.
 **/
#line 328 "../src/vixn-application.gob"
VixnWindow * 
vixn_application_create_window (VixnApplication * self, const char * cwd, char const * const* env)
{
#line 641 "vixn-application.c"
	VixnApplicationClass *klass;
#line 328 "../src/vixn-application.gob"
	g_return_val_if_fail (self != NULL, (VixnWindow * )0);
#line 328 "../src/vixn-application.gob"
	g_return_val_if_fail (VIXN_IS_APPLICATION (self), (VixnWindow * )0);
#line 647 "vixn-application.c"
	klass = VIXN_APPLICATION_GET_CLASS(self);

	if(klass->create_window)
		return (*klass->create_window)(self,cwd,env);
	else
		return (VixnWindow * )(0);
}
#line 328 "../src/vixn-application.gob"
static VixnWindow * 
___real_vixn_application_create_window (VixnApplication * self G_GNUC_UNUSED, const char * cwd, char const * const* env)
{
#line 659 "vixn-application.c"
#define __GOB_FUNCTION__ "Vixn:Application::create_window"
{
#line 331 "../src/vixn-application.gob"
	
        return vixn_window_new(self, cwd, env);
    }}
#line 666 "vixn-application.c"
#undef __GOB_FUNCTION__

/**
 * vixn_application_new:
 * Creates the application.
 **/
#line 339 "../src/vixn-application.gob"
VixnApplication * 
vixn_application_new (void)
{
#line 677 "vixn-application.c"
#define __GOB_FUNCTION__ "Vixn:Application::new"
{
#line 341 "../src/vixn-application.gob"
	
        return GET_NEW_VARG(
                "application-id", "org.vixn.vixn2",
                "flags", G_APPLICATION_HANDLES_COMMAND_LINE,
                NULL);
    }}
#line 687 "vixn-application.c"
#undef __GOB_FUNCTION__

