from .vicflags import *
from . import vicmd

masters = {}
""" Master dictionary of keystroke descriptions keyed by keystroke sequence.
Each entry is a BoundViCommand. """

def bind_builtins():
    """ Bind all built-in commands. """
    global masters
    for vi_command in list(vicmd.commands.values()):
        dflt_keys = vi_command.dflt_key
        if hasattr(dflt_keys, "isspace"):
            dflt_keys = [dflt_keys]
        for ks in dflt_keys:
            vicmd.bind_command(masters, ks, vi_command)

def bind_digits():
    """ Number keys also have to be bound, except 0 which is special case """
    global masters
    dummy_vic = vicmd.ViCommand(None, DIGIT)
    for n in range(1, 10):
        vicmd.bind_command(masters, str(n), dummy_vic)
        vicmd.bind_command(masters, '<k%d>' % n, dummy_vic)

bind_builtins()
bind_digits()

defaults = masters.copy()
""" defaults is the single set of keybindings applying globally. """

