""" List of buffers is stored here. """

import atexit
import os

from gi.repository import Gtk

from . import vixi18n

buffers = []

throwbacks = 0

def save_all(force = True):
    """ If force is True, it saves even if we might be overwriting existing
    file, but only if modified. """
    global buffers
    for b in buffers:
        b.save(force)

def destroying_all():
    for b in buffers:
        b.notify_parent_closing()

def any_modified():
    """ Returns whether any buffers have been modified. """
    global buffers
    for b in buffers:
        if b.get_modified():
            return True
    return False

def find_filename(filename):
    """ Finds a buffer editing the named file. filename must be full
    path (use SettingsClient.expandpath()). """
    global buffers
    for b in buffers:
        if b.filename and os.path.samefile(b.filename, filename):
            return b
    return None

def check_quit():
    if not len(buffers) and not throwbacks:
        Gtk.main_quit()


_filename_index = 0

def generate_filename(cwd, template = _("Untitled_%d"), index = None,
        joiner = os.path.join):
    """ returns filename and new index. """
    if index == None:
        global _filename_index
        index = _filename_index
        glbl = True
    else:
        glbl = False
    while True:
        index += 1
        if glbl:
            _filename_index = index
        filename = joiner(cwd, template % index)
        if not os.path.exists(filename):
            return filename, index



atexit.register(destroying_all)
