from gi.repository import Gdk, Gtk
from .mode import SELECT, SELBYLINE, SELRECT

clipboards = {}

seltext = None
selmode = SELECT

def set_text(name, text, mode = SELECT):
    global clipboards, seltext, selmode
    if name:
        clipboards[name] = [text, mode]
    else:
        seltext = text
        selmode = mode
        Gtk.Clipboard.get(Gdk.SELECTION_CLIPBOARD).set_text(text, -1)
        Gtk.Clipboard.get(Gdk.SELECTION_PRIMARY).set_text(text, -1)

def get_text_and_selmode(name):
    global clipboards, seltext, selmode
    if name:
        return clipboards[name]
    else:
        # FIXME: wait_for_text() causes iteration of main loop,
        # could this cause reentrancy problems? Probably not in
        # practice otherwise TextBuffer shouldn't be able to have
        # its paste_clipboard method.
        text = Gtk.Clipboard.get(Gdk.SELECTION_CLIPBOARD).wait_for_text()
        if not text:
            text = Gtk.Clipboard.get(Gdk.SELECTION_PRIMARY).wait_for_text()
        # Test whether text on clipboard matches what we copied/cut; if it does
        # use the selmode that goes with it
        if text == seltext:
            mode = selmode
        elif text[-1] == '\n':
            mode = SELBYLINE
            text = text[:-1]
        else:
            mode = SELECT
        return [text, mode]
