from gi.repository import GObject, Gtk

style_provider = Gtk.CssProvider()
style_provider.load_from_data(
        b"""* {
        -GtkButton-default-border : 0;
        -GtkButton-default-outside-border : 0;
        -GtkButton-inner-border: 0;
        -GtkWidget-focus-line-width : 0;
        -GtkWidget-focus-padding : 0;
        padding: 0;
        }""")

class CloseButton(Gtk.Button):
    def __init__(self):
        global style_provider
        GObject.GObject.__init__(self)
        self.set_relief(Gtk.ReliefStyle.NONE)
        self.set_focus_on_click(False)
        self.get_style_context().add_provider(style_provider,
                Gtk.STYLE_PROVIDER_PRIORITY_APPLICATION)
        self.set_name("multitab-close-button")

        self.image = Gtk.Image()
        self.image.set_from_stock(Gtk.STOCK_CLOSE, Gtk.IconSize.MENU)
        self.__set_size()
        self.image.show()
        self.add(self.image)
        self.connect("style-updated", self.__set_size)

    def __set_size(self, *args):
        r, w, h = Gtk.icon_size_lookup_for_settings(self.get_settings(),
                Gtk.IconSize.MENU)
        self.set_size_request(w + 2, h + 2)

