from gi.repository import GtkSource

from . import dialog
from . import dirs

_manager = None

def get_manager():
    global _manager
    if not _manager:
        _manager = GtkSource.StyleSchemeManager()
        ds = dirs.get_all_config("schemes")
        # Reverse because we're prepending but want to keep order returned by
        # dirs
        ds.reverse()
        for d in ds:
            _manager.prepend_search_path(d)
    return _manager

def get_scheme(id):
    m = get_manager()
    scm = None
    try:
        scm = m.get_scheme(id.lower())
        if not scm:
            raise Exception()
    except:
        try:
            scm = m.get_scheme("classic")
            if not scm:
                raise Exception()
        except:
            dialog.error(None,
                _("Scheme '%s' not found and unable to fall back on 'classic'")\
                        % id)
        else:
            dialog.warning(None,
                _("Scheme '%s' not found, falling back on 'classic'") % id)
    return scm
