""" A keystroke may have any of these meanings, some ORred together. """

COMMAND = 0     
" Standalone command. "

SEQUENCE = 1 << 0
" Needs further keystroke(s) to form a complete command "

DIGIT = 1 << 1
" Numerical digit "

ZERO = 1 << 2   
" Digit only if not first in a chain, otherwise command "

CHANGE = 1 << 3
" Causes a change eg cut, paste "

INSERT = 1 << 4
" Enters insert mode (implies CHANGE and CLEARSEL) "

MOVEMENT = 1 << 5
" Movement command "

NEEDSRANGE = 1 << 6
""" Needs to be supplemented by a movement, or acts on
selection. May also have special cases like dd or << """

NEEDSARG = 1 << 7
" Takes a single-key argument such as a register or like 'f' "

REGMOD = 1 << 8
' Can be modified by a register set by " '

INCOMPLETE = 1 << 9
" Meta-flag, gets set by add_command if a command is incomplete on its own "

SELECT = 1 << 10
" Enters selection mode "

CLEARSEL = 1 << 11
" Clear selection when invoked "

COMPOUND = 1 << 12
" A change followed by an insert operation (implies INSERT) "

EXCOMMAND = 1 << 13
" Bound to an ex command "

TAIL = 1 << 14
" Causes some other command to be executed, like repeat (.) "

