""" Vixn's exception base classes are defined here. """

class CodeError(Exception):
    """ For errors (probably) caused by vixn's code. """
    pass

class FileError(Exception):
    """ For errors caused by missing files that should have been installed
    with vixn. """
    pass

class SysError(Exception):
    """ Problems with the system vixn is running on. """
    pass

class UserError(UserWarning):
    """ For errors in users' code/commands. """
    pass

class KeynameError(UserError):
    """ Error in command-key name eg < with no >. """
    pass
